---
title: WebGLRenderingContext.bufferSubData()
slug: Web/API/WebGLRenderingContext/bufferSubData
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
  - bufferSubData
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.bufferSubData()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> updates a subset of a buffer object's data store.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">// WebGL1:
void gl.bufferSubData(target, offset, ArrayBuffer srcData);
void gl.bufferSubData(target, offset, ArrayBufferView srcData);

// WebGL2:
void gl.bufferSubData(target, dstByteOffset, ArrayBufferView srcData, srcOffset, length);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>target</dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target). Possible values:
 <ul>
  <li><code>gl.ARRAY_BUFFER</code>: Buffer containing vertex attributes, such as vertex coordinates, texture coordinate data, or vertex color data.</li>
  <li><code>gl.ELEMENT_ARRAY_BUFFER</code>: Buffer used for element indices.</li>
  <li>When using a {{domxref("WebGL2RenderingContext", "WebGL 2 context", "", 1)}}, the following values are available additionally:
   <ul>
    <li><code>gl.COPY_READ_BUFFER</code>: Buffer for copying from one buffer object to another.</li>
    <li><code>gl.COPY_WRITE_BUFFER</code>: Buffer for copying from one buffer object to another.</li>
    <li><code>gl.TRANSFORM_FEEDBACK_BUFFER</code>: Buffer for transform feedback operations.</li>
    <li><code>gl.UNIFORM_BUFFER</code>: Buffer used for storing uniform blocks.</li>
    <li><code>gl.PIXEL_PACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
    <li><code>gl.PIXEL_UNPACK_BUFFER</code>: Buffer used for pixel transfer operations.</li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>dstByteOffset</dt>
 <dd>A {{domxref("GLintptr")}} specifying an offset in bytes where the data replacement will start.</dd>
 <dt>srcData {{optional_inline}}</dt>
 <dd>An {{jsxref("ArrayBuffer")}}, {{jsxref("SharedArrayBuffer")}} or one of the {{domxref("ArrayBufferView")}} typed array types that will be copied into the data store.</dd>
 <dt>srcOffset</dt>
 <dd>A {{domxref("GLuint")}} specifying the element index offset where to start reading the buffer.</dd>
 <dt><code>length</code> {{optional_inline}}</dt>
 <dd>A {{domxref("GLuint")}} defaulting to 0.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>A <code>gl.INVALID_VALUE</code> error is thrown if the data would be written past the end of the buffer or if <code>data</code> is <code>null</code>.</li>
 <li>A <code>gl.INVALID_ENUM</code> error is thrown if <code>target</code> is not one of the allowed enums.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Using_bufferSubData">Using <code>bufferSubData</code></h3>

<pre class="brush: js">var canvas = document.getElementById('canvas');
var gl = canvas.getContext('webgl');
var buffer = gl.createBuffer();
gl.bindBuffer(gl.ARRAY_BUFFER, buffer);
gl.bufferData(gl.ARRAY_BUFFER, 1024, gl.STATIC_DRAW);
gl.bufferSubData(gl.ARRAY_BUFFER, 512, data);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.5", "bufferSubData")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glBufferSubData.xml", "glBufferSubData")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL ES 2 API.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glBufferSubData.xhtml", "glBufferSubData")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL ES 3 API.<br>
    <br>
    Adds new <code>target</code> buffers:<br>
    <code>gl.COPY_READ_BUFFER</code>,<br>
    <code>gl.COPY_WRITE_BUFFER</code>,<br>
    <code>gl.TRANSFORM_FEEDBACK_BUFFER</code>,<br>
    <code>gl.UNIFORM_BUFFER</code>,<br>
    <code>gl.PIXEL_PACK_BUFFER</code>,<br>
    <code>gl.PIXEL_UNPACK_BUFFER</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.bufferSubData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.createBuffer()")}}</li>
 <li>{{domxref("WebGLRenderingContext.bufferData()")}}</li>
 <li>Other buffers: {{domxref("WebGLFramebuffer")}}, {{domxref("WebGLRenderbuffer")}}</li>
</ul>
